package exceptions

import "fmt"

type NotFoundError struct {
	Message string
}

func NewNotFoundError(msg string) *NotFoundError {
	return &NotFoundError{Message: msg}
}

func NewNotFoundErrorFromError(msg string, err error) *NotFoundError {
	return &NotFoundError{Message: fmt.Sprintf("所需数据未找到，%s，%v", msg, err)}
}

func (e NotFoundError) Error() string {
	return e.Message
}
